CONFIG = {
	-- password of the server once it has loaded completely. you should use this instead of sv_password because it sets it after everything is complete.
	PASSWORD = "", 
	
	-- message is sent to player when they log in. the first %s is the player's name.
	WELCOMEMSG = "[Message]: Welcome to " .. game'sv_name' .. "- %s!", 
	
	-- maximum number of monsters on the map at one time. if set to 0, monsters.lua is not loaded at all.
	MAXMONSTERS = 50, 
	-- maximum inventory items a player can carry.
	MAXITEMS = 50, 
	-- maximum height an item stack on the ground can be (they can be as high as you want, but only the top few will be shown when this is set).
	MAXHEIGHT = 5, 
        MAXEXP = 22098, 
        CLEANITEMSDELAY= 2,
	
	-- print colour codes to console? 
	PRINTCOLOURTOCONSOLE = true,
	
	EXP = {
		-- function for calculation experience for each level.
		CALC = function(level)
			level = level - 1
			return (level)^3 - 3 * (level)^2 + 8 * (level)
		end,
		STATS = 1, --ignore
	}, 
	
	STATS = {'Experience', 'Level', 'Money'}, --ignore
	
	STATSMENU = {"hp", "atk", "def", "spd"}, --ignore
	
	-- initial player table. info is a table consisting of strings to inform the player when (s)he logs in. the table is cleared after logging in.
	-- if you would like to set initial level, money, equip etc this should be where you do it.
	PLAYERINIT = {
		Experience = 0,
		Level = 1,
		Money = 3500,
		HP = 100,
		MP = 100,
		cAtk2 = 0,
		cDef2 = 0,
		cSpd2 = 0,
		class = 0,
		Inventory = {6, 6, 6, 6, 6, 6, 6, 6}, 
		Equipment = {}, 
		Spawn = {272, 144}, 
		Tutorial = {},
		Info = {},
	}, 
	
	-- slot names for each slot. can be customised.
	SLOTS = {
		"Helmet", 
		"Armour", 
		"Weapon", 
		"Ring", 
		"Legs", 
		"Boots", 
		"Wings", 
		"Ring", 
		"Runes", 
	}, 
	
	-- colour for hudtxt (only one for now... no point then)
	HUDTXT = {
		SAFE = 49, 
	}, 
	-- pixels to leave between each line of hudtxt
	PIXELS = 14, 
	
	-- used for ^[1-9a-z] colour codes
	COLOURS = {
		"192192192",
		"128128128",
		"255000000",
		"000255000",
		"000000255",
		"255255000",
		"000255255",
		"255000255",
		"128000000",
		"000128000",
		"128128000",
		"000000128",
		"000128128",
		"128000128",
		"255128128",
		"128255128",
		"128128255",
		"255128000",
		"000255128",
		"128000255",
		"255000128",
		"128255000",
		"000128255",
		"128000000",
		"000128000",
		"000000128",
		"255128255",
		"128255255",
		"255128255",
		"192128128",
		"128192128",
		"128128192",
		"192192128",
		"128192192",
		"192128192",
		[0] = "255255255",
	}, 
	
	-- tiles that cannot be walked on unless you have an item that allows water walking (or was it a specific mount only?)
	WATERTILES = {25},
	
	-- if map data (safe zone, houses, monster spawn etc) is not found, use this
	DEFAULTMAP = 'rpg_mapb', 
	
	-- experience gained will be multiplied by this value.
	EXPRATE = 1, 
	-- money loot will be multiplied by this value.
	MONEYRATE = 1, 
	-- drop chance will be multiplied by this value.
	DROPRATE = 1, 
	-- player death money loot will be multiplied by this value.
	PLAYERMONEYRATE = 1, 
	-- player drop chance will be this value out of 10000. i.e. 2000 means 20%
	PLAYERDROPRATE = 2000, 
	
	EXHAUST = {
		-- ms after each talk, any faster, the message will not be showed
		TALK = 500, 
		-- ms after each pick up attempt, any faster, the pick up will be aborted
		PICK = 500, 
		-- ms after each use attempt, any faster, the use will be aborted
		USE = 2000, 
	},
	
	WEAPONRANGE = { -- range of cs2d weapons. e.g. [50] = 27 means wpnid 50 has range of 27 pixels. i should get around to change this to ingame ids some time
		[34] = 350, 
		[46] = 128, 
		[50] = 27, 
		[69] = 32, 
		[78] = 32, 
		[75] = 350,
	}, 
	WEAPONWIDTH = { -- angular range of cs2d weapons. e.g. [50] = math.pi*2/3 means 120 degrees or 2pi/3 range of attack.
		[34] = math.pi/12, 
		[46] = math.pi/8,  
		[50] = math.pi*2/3, 
		[69] = math.pi*2/3, 
		[78] = math.pi*2/3, 
		[75] = math.pi/12,
	}
}

SAFEZONE = { -- safezones e.g. {{x1, y1},{x2, y2}} means a rectangular area from (x1, y1) to (x2, y2)
	['rpg_mapb'] = {
	{{0,0},{38,31}},
	{{70,53},{80,62}},
	{{101,2},{155,58}},
	{{117,59},{155,62}},
	{{155,32},{165,35}},
	{{203,0},{255,32}},
	{{256,8},{270,26}},
	{{79,50},{90,58}},
	{{60,70},{67,80}},
	{{68,73},{73,95}},
	{{74,92},{96,95}},
	{{97,75},{103,94}},
	{{78,96},{99,113}},
	{{59,81},{68,93}},
	{{100,77},{119,91}},
	{{120,79},{125,99}},
	{{126,95},{152,99}},
	{{153,79},{159,97}},
	{{46,59},{73,95}},
	{{53,63},{67,80}},
	{{78,25},{85,32}},
	}	
}

NOPVPZONE = { -- non-pvp zones, preventing pvp within the area. syntax same as above
	['rpg_mapb'] = {
	{{0,32},{39,145}},
	{{40,0},{69,76}},
	{{70,0},{85,52}},
	{{166,17},{194,53}},
	{{201,33},{296,81}},
	{{256,27},{283,32}},
	{{271,16},{288,32}},
	{{296,0},{399,55}},
	}	
}

NOMONSTERSZONE = { -- no-monsters zones, preventing monsters spawning/entering/attacking inside the area. syntax same as above
	['rpg_mapb'] = {
	{{74,76},{96,91}},
	{{126,81},{152,94}},
	}
}

PVPZONE = { -- deathmatch zones, if a player dies in this area, he will drop $100 and nothing else. monsters DO spawn here now, but you can set it to be a no-monsters zone to prevent that. guess the syntax
	['rpg_mapb'] = {
	{{75,77},{95,90}},
	{{127,82},{151,93}},
	}
}

--[[ 	houses... i'll try to explain
		pos1 to pos2 forms a rectangular area similar to above. this represents the area the house controls.
		ent is right outside the main entrance of the house. IT IS NOT PART OF THE HOUSE! this is typically used when you kick yourself out of your house
			that reminds me, i have to make a command to kick people from your house
		door is the main entrance of the house. this should be in the house itself. is used when buying and checking house info, among others
		price is the price per day. this includes server offline time!
		owner should be left as nil
		endtime should be left as nil
		allow should be left as an empty array
		doors is the allow list of the doors that belong to the house.
			this also helps to open/close doors as long as you name the triggers in the houses as HOUSEID_DOORID
			e.g. for the first house, doors = {[1] = {}} means a door with a trigger 1_1 will open if you have door rights.
			
		I DID NOT NOTICE THAT I HAVE DONE DOCUMENTATION FOR HOUSES ALREADY. I WILL JUST COPY IT OVER AND LEAVE TWO SETS FOR YOU TO READ.
		
		HOUSES
		For house areas, they have to be rectangular.
		Fill in the house areas in config.lua

		e.g.
		{pos1 = {87,2}, pos2 = {89,5}, ent = {89,6}, door = {89,5}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},

		pos1 and pos2 are the top left and bottom right of the rectangle respectively.
		ent is tile pos of the tile infront of the door, used to buy the house.
		door is tile pos of the main door of the house.
		price is the price of the house per 24 hours of ownership.
		owner is the default owner of the house. just leave it as nil, for initialisation purposes.
		endtime is the time the house ownership ends, in Unix time.
		allow is the list of allowed players, just leave it as a blank table for initialisation purposes.
		doors is the list of doors as represented in the map.
		e.g. if the name of the door is 12_3, it is door 3 of house 12.
]]
HOUSES = { 
	['rpg_mapb'] = {
		{pos1 = {117,8}, pos2 = {122,12}, ent = {119,13}, door = {119,12}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 1_1
		{pos1 = {125,8}, pos2 = {130,12}, ent = {127,13}, door = {127,12}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 2_1
		{pos1 = {133,8}, pos2 = {137,11}, ent = {135,13}, door = {135,12}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 3_1	
		{pos1 = {141,8}, pos2 = {145,12}, ent = {143,13}, door = {143,12}, price = 450, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 4_1
		{pos1 = {116,16}, pos2 = {122,21}, ent = {119,15}, door = {119,16}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 5_1
		{pos1 = {124,16}, pos2 = {130,21}, ent = {127,15}, door = {127,16}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 6_1
		{pos1 = {132,16}, pos2 = {138,21}, ent = {135,15}, door = {135,16}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 7_1
		{pos1 = {140,16}, pos2 = {146,21}, ent = {143,15}, door = {143,16}, price = 250, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 8_1
		{pos1 = {115,25}, pos2 = {123,31}, ent = {119,32}, door = {119,31}, price = 250, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 9_1
		{pos1 = {125,25}, pos2 = {133,31}, ent = {129,32}, door = {129,31}, price = 250, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 10_1
		{pos1 = {135,25}, pos2 = {143,31}, ent = {139,32}, door = {139,31}, price = 250, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 11_1
		{pos1 = {145,25}, pos2 = {153,31}, ent = {149,32}, door = {149,31}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 12_1
		{pos1 = {115,35}, pos2 = {123,41}, ent = {119,34}, door = {119,35}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 13_1
		{pos1 = {125,35}, pos2 = {133,41}, ent = {129,34}, door = {129,35}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 14_1	
		{pos1 = {135,35}, pos2 = {143,41}, ent = {139,34}, door = {139,35}, price = 450, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 15_1
		{pos1 = {145,35}, pos2 = {153,41}, ent = {149,34}, door = {149,35}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 16_1
		{pos1 = {115,45}, pos2 = {123,51}, ent = {119,44}, door = {119,45}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 17_1
		{pos1 = {125,45}, pos2 = {133,51}, ent = {129,44}, door = {129,45}, price = 300, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 18_1
		{pos1 = {135,45}, pos2 = {143,51}, ent = {139,44}, door = {139,45}, price = 250, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 19_1
		{pos1 = {145,45}, pos2 = {153,51}, ent = {149,44}, door = {149,45}, price = 250, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}}, -- 20_1
	}
}
