
function DrawRect(x,y,w,h,id,rgb,l)
	id = id or 0;
	l = l or 2;
	rgb = rgb or {255,255,255};
	local img = image("gfx/plot.bmp", x+(w/2), y+(h/2), l, id);
	imagescale(img, w, h);
	imagecolor(img, rgb[1], rgb[2], rgb[3]);
	return img;
end

function DrawLine(x,y,x2,y2,w,id,rgb,l)
	local angle = (math.atan2(y2-y, x2-y)*180/math.pi)%360;
	local dist = math.distance(x,y,x2,y2);

	id = id or 0;
	l = l or 2;
	w = w or 1;
	rgb = rgb or {255,255,255};
	local img = image("gfx/plot.bmp", x, y, l, id);
	imagescale(img, dist, w);
	imagepos(img, x+(dist/2), y+(dist/2), angle);
	imagecolor(img, rgb[1], rgb[2], rgb[3]);
	return img;
end

function UpdateRect(r, x, y, w, h, rgb)
	rgb = rgb or {255, 255, 255};
	imagepos(r, x+(w/2), y+(h/2), 0);
	imagescale(r, w, h);
	imagecolor(r, rgb[1], rgb[2], rgb[3]);
end

function ConvertHSVtoRGB(h,s,v)
	-- h should be from 0 to 360; s & v from 0 to 1
	local p1, p2, p3, i, f;
	local xh;

	if ( h == 360 ) then
		h = 0;
	end

	xh = h/60.0;
	i = math.floor(xh);
	f = xh - i;
	p1 = v * (1 - s);
	p2 = v * (1 - (s*f));
	p3 = v * (1 - (s * (1-f)));
	--print(i)
	if ( i == 0 ) then
		return v,p3,p1;
	end

	if ( i == 1 ) then
		return p2,v,p1;
	end

	if ( i == 2 ) then
		return p1,v,p3;
	end

	if ( i == 3 ) then
		return p1,p2,v;
	end

	if ( i == 4 ) then
		return p3,p1,v;
	end

	if ( i == 5 ) then
		return v,p1,p2;
	end
end
